@page "/buildingdata"

@using AntDesign
@using System.ComponentModel
@using System.Text;
@using System.Text.RegularExpressions
@using System.Net;
@using FIOWebServer.Models
@using FIOWebServer.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState

@implements IDisposable

<h1>Building Data</h1>
<FIOWebServer.Components.LoadingWrapper RequiresAuth="true" @bind-ProgressCount="ProgressCount" TotalProgress="2">
    <MatIconButton Style="outline:0" Icon="refresh" OnClick="@(() => { _ = Refresh(); })"></MatIconButton>

    <FIOWebServer.Components.UserOrGroup AllowancesRequired="@RequiredAllowances" @bind-CurrentUserName="ActiveUserName" UserNameSelectionChanged="@Refresh"/>

    <div>Condition Threshold: <AntDesign.InputNumber @bind-Value="@BuildingConditionThreshold" Formatter="ThresholdFormatter" Parser="ThresholdParser" DefaultValue="100d" Min="30" Max="100"></AntDesign.InputNumber></div><br/>
    <div><Checkbox CheckedChange="@CheckNonProductionBuildings">Show Non-Production Buildings</Checkbox></div>
    <Table DataSource="FilteredBuildingData" 
           TreeChildren="item=>item.Children"
           PageSize="50"
           Size=@TableSize.Small
           TItem="BuildingDataModel"
           Bordered="true">
        <Column Width="75" TData="string" Title="" Sortable="false">
            <div style="text-align:right">
                @switch(context.CheckState)
                {
                    case CheckedState.Unchecked:
                        <Checkbox Checked="false" CheckedChange="@(() => {context.Check(); SelectedBuildingDataChanged(); })"></Checkbox>
                        break;
                    case CheckedState.Indeterminate:
                        <Checkbox Indeterminate="true" CheckedChange="@(() => {context.Check(); SelectedBuildingDataChanged(); })"></Checkbox>
                        break;
                    case CheckedState.Checked:
                        <Checkbox Checked="true" CheckedChange="@(() => {context.Check(); SelectedBuildingDataChanged(); })"></Checkbox>
                        break;
                }
            </div>
        </Column>
        <Column Width="175" TData="string" Title="Planet" @bind-Field="@context.PlanetDisplayName" Sortable="true" SorterCompare="@((v1, v2) => string.CompareOrdinal(v1, v2))">
            <div>@context.PlanetDisplayName</div>
        </Column>
        <Column Width="75" TData="string" Title="Building" Sortable="false">
            <div>@context.BuildingTicker</div>
        </Column>
        <Column Width="75" TData="string" Title="Condition" Sortable="false">
            <div>
                @if (context.Condition != null)
                {
                    @(((float)context.Condition).ToString("P3"))
                }
        </div>
        </Column>
        <Column Width="75" TData="string" Title="Material" Sortable="false">
            <div>@context.MaterialTicker</div>
        </Column>
        <Column Width="75" TData="string" Title="Amount" Sortable="false">
            <div>
                @if (context.MaterialAmount != null)
                {
                    @((int)context.MaterialAmount)
                }
            </div>
        </Column>
        <Column TData="string" Title="" Sortable="false"/>
    </Table>

    <h2>Shopping Cart</h2>
    <Table DataSource="ShoppingCart"
           PageSize="50"
           Size=TableSize.Small
           TItem="ShoppingCartModel"
           Bordered="true">
           <Column Width="75" TData="string" Title="Material" Sortable="false">
               <div>@context.Ticker</div>
           </Column>
           <Column Width="75" TData="string" Title="Amount" Sortable="false">
               <div>@context.Amount</div>
           </Column>
           <Column TData="string" Title="" Sortable="false"/>
    </Table>
</FIOWebServer.Components.LoadingWrapper>